#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  DarkSlateGray
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style7  STYLE_DASH
#property indicator_width1  2
#property indicator_style2  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[], double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern double Length1                 = 50;
extern double Length2                 = 5;
extern double Length3                 = 7;
extern double Phase                   = 0.0;
extern bool   SmoothDouble            = false;
extern int    Price                   = 8;

extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability1  = 0.025;
extern double DzStartBuyProbability2  = 0.15;
extern double DzStartSellProbability1 = 0.025;
extern double DzStartSellProbability2 = 0.15;

double tsi[];
double signal[];
double bl1[];
double bl2[];
double sl2[];
double sl1[];
double zli[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,tsi);
   SetIndexBuffer(1,signal);
   SetIndexBuffer(2,bl1);
   SetIndexBuffer(3,bl2);
   SetIndexBuffer(4,sl2);
   SetIndexBuffer(5,sl1);
   SetIndexBuffer(6,zli);
  
      IndicatorShortName("Dynamic Double zone Blau jurik ergodic true strength index ("+DoubleToStr(Length1,1)+","+DoubleToStr(Length2,1)+","+DoubleToStr(Length3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = getPrice(Price,i) - getPrice(Price,i+1);
         double avg = iDSmooth(iDSmooth(        priceDiff, Length1,Phase,SmoothDouble,i, 0),Length2,Phase,SmoothDouble,i,20);
         double ava = iDSmooth(iDSmooth(MathAbs(priceDiff),Length1,Phase,SmoothDouble,i,40),Length2,Phase,SmoothDouble,i,60);
         
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            
            signal[i] = iDSmooth(tsi[i],Length3,Phase,SmoothDouble,i,80);
            
            if (DzStartBuyProbability1  > 0) bl1[i] = dzBuyP (tsi, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
            if (DzStartBuyProbability2  > 0) bl2[i] = dzBuyP (tsi, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
            if (DzStartSellProbability1 > 0) sl1[i] = dzSellP(tsi, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
            if (DzStartSellProbability2 > 0) sl2[i] = dzSellP(tsi, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
                                             zli[i] = dzSellP(tsi, 0.5                    , DzLookBackBars, Bars, i, 0.0001);

            //
            //
            //
            //
            //
                           
      }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][100];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

